%{
#include "parse-calc.h"

#define YY_USER_ACTION \
  yylloc->last_column += yyleng;

#define STEP()                                  \
  do {                                          \
    yylloc->first_column = yylloc->last_column; \
    yylloc->first_line = yylloc->last_line;     \
  } while (0)
%}

%option noyywrap nounput noinput debug

%%
%{
  STEP();
%}

"+"     return TOK_PLUS;
"*"     return TOK_STAR;
"/"     return TOK_SLASH;
"-"     return TOK_MINUS;
"("     return TOK_LPAR;
")"     return TOK_RPAR;
[0-9]+  yylval->ival = strtol (yytext, NULL, 0); return TOK_NUMBER;

[ \t]+  STEP(); continue;
\n      {
          ++yylloc->last_line; 
          yylloc->last_column = 1; 
          return TOK_EOL;
        }
.       ++*nerr; fprintf (stderr, "invalid character: %c\n", *yytext);
%%

/*
Local Variables:
mode: C
End:
*/
